<template functional>
  <div id="lecture_item_list_wrapper">
    <div v-if="props.list.length === 0">
      {{ parent.$t('ITEM.LIST_EMPTY') }}
    </div>
    <div v-else>
      <el-table 
        :data="props.list.filter(item => item.type !== 7 && item.type !== '개인화 문항 구성 요소')"
        id="LectureItemList"
        v-sortable="data.attrs.sortableOptions">
        <el-table-column
          type="index"
          :label="parent.$t('LECTURE_LIST.NUMBER')"
          width="100"
          align="center"
        ></el-table-column>

        <el-table-column
          prop="type"
          :label="parent.$t('LECTURE_LIST.TYPE')"
          width="150"
          align="center"
        >
          <template slot-scope="scope">
            <span v-if="scope.row.type === '문항'">
              {{ parent.$t('ITEM.QUESTION') }}
            </span>
            <span v-else-if="scope.row.type === '설문'">
              {{ parent.$t('ITEM.SURVEY') }}
            </span>
            <span v-else-if="scope.row.type === '실습'">
              {{ parent.$t('PRACTICE.PRACT_ITEM') }}
            </span>
            <span v-else-if="scope.row.type === '토론'">
              {{ parent.$t('ITEM.DISCUSSION') }}
            </span>
            <span v-else-if="scope.row.type === '자료'">
              {{ parent.$t('ITEM.NOTE') }}
            </span>
            <span v-else-if="scope.row.type === '개인화 문항'">
              {{ parent.$t('ITEM.INDIV') }}
            </span>
          </template>
        </el-table-column>

        <el-table-column
          prop="name"
          :label="parent.$t('ITEM.NAME')"
          align="center"
        ></el-table-column>

        <!-- 아이템별 활성화 시간 설정 기능 사라짐
        <el-table-column
          prop="offset"
          label="활성화 시각"
          width="200"
          align="center"
          v-if="props.lectureType !== 0"
        >
          <template slot-scope="scope">
            {{ scope.row.offset }}
          </template>
        </el-table-column>-->

        <el-table-column
          label="-"
          width="80"
          align="center"
        >
          <template slot-scope="scope">
            <el-button size="small" @click="listeners['edit'](scope.row.lecture_item_id)">{{ parent.$t('LECTURE_LIST.EDIT') }}</el-button>
          </template>
        </el-table-column>

        <el-table-column
          label="-"
          width="110"
          align="center"
        >
          <template slot-scope="scope">
            <el-button size="small" @click="listeners['simulate'](scope.row.lecture_item_id)">{{ parent.$t('ITEM.PREVIEW') }}</el-button>
          </template>
        </el-table-column>

        <el-table-column
          label="-"
          width="80"
          align="center"
        >
          <template slot-scope="scope">
            <el-button size="small" type="danger" @click="listeners['delete'](scope.$index)">{{ parent.$t('LECTURE_LIST.DELETE') }}</el-button>
          </template>
        </el-table-column>

      </el-table>
    </div>
  </div>
</template>

<script>

export default {
  name: 'LectureItemList',
  props: {
    type: {
      type: String,
      required: true,
      validator(value) {
        const allowedTypeList = ['TEACHER', 'STUDENT'];
        if (!allowedTypeList.includes(value)) {
          // eslint-disable-next-line no-console
          console.error(`prop "type" should be one of ${allowedTypeList}`);
          return false;
        }
        return true;
      },
    },
    list: {
      type: Array,
      required: true,
      validator(value) {
        if (!Array.isArray(value)) {
          // eslint-disable-next-line no-console
          console.error('prop "list" should be type Array');
          return false;
        }
        if (value.length === 0) {
          return true;
        }
        const firstElement = value[0];
        const allowedKeyOfClassListItem = ['id']; // TODO: improve this list
        const firstElementKeySet = new Set(Object.keys(firstElement));
        if (firstElementKeySet.size === 0) {
          throw new Error('ClassList empty element received.');
        }
        for (let i = 0; i < allowedKeyOfClassListItem; i += 1) {
          const expectedKey = allowedKeyOfClassListItem[i];
          if (!firstElementKeySet.has(expectedKey)) {
            // eslint-disable-next-line no-console
            console.error(`prop "list" should have \`${expectedKey}\``);
            return false;
          }
        }
        return true;
      },
    },
    lectureType: {
      type: Number,
      required: true,
    },
  },
};
</script>
